// CButton.cpp
// by Comanche

#include "CButton.h"
#include "CLog.h"
#include "CGraphics.h"
#include "CMain.h"
#include "CTexture.h"
#include "CMenu.h"

extern CGraphics Graphics;
extern CMain GameMain;
extern CLog Log;
extern CMenu Menu;

//////////////////////////////////////////////////////////////////////////////////

CButton::CButton(int x1,int y1,int x2,int y2, char *string, char *bitmap)
{
	Texture = new CTexture(bitmap);
	if(!Texture->isfailure)
		isTextured=TRUE;

	Bx=x1;	By=y1;
	Bx2=x2;	By2=y2;
	sprintf(caption,"%s",string);
	waspressed=TRUE;
}

//////////////////////////////////////////////////////////////////////////////////

CButton::~CButton()
{
	delete Texture;
}

//////////////////////////////////////////////////////////////////////////////////

BOOL CButton::RedrawButton()
{
	Graphics.Lock();
	Graphics.DrawButton(Bx,By,Bx2,By2);
	DrawPicture(FALSE);
	Graphics.UnLock();
	Graphics.OSGetDC();
	Graphics.Text((Bx+Bx2)/2,By+3,caption);
	Graphics.OSReleaseDC();
	return(TRUE);
}

//////////////////////////////////////////////////////////////////////////////////

BOOL CButton::RedrawPushedButton()
{
	Graphics.Lock();
	Graphics.DrawPushedButton(Bx,By,Bx2,By2);
	DrawPicture(FALSE);
	Graphics.UnLock();
	Graphics.OSGetDC();
	Graphics.Text((Bx+Bx2)/2,By+4,caption);
	Graphics.OSReleaseDC();
	return(TRUE);
}

//////////////////////////////////////////////////////////////////////////////////

BOOL CButton::TestIfPressed()
{
	if (GameMain.CheckMouseRange(Bx,By,Bx2,By2,TRUE))
	{
		Graphics.Lock();
		Graphics.DrawPushedButton(Bx,By,Bx2,By2);
		DrawPicture(TRUE);
		Graphics.UnLock();
		while(GameMain.MouseB[0])
		{
			GameMain.GetMouseInfo();
			if(GameMain.CheckMouseRange(Bx,By,Bx2,By2,FALSE))
			{	
				Graphics.Lock();
				Graphics.DrawPushedButton(Bx,By,Bx2,By2);
				DrawPicture(TRUE);
				Graphics.UnLock();
				Graphics.OSGetDC();
				Graphics.Text((Bx+Bx2)/2,By+4,caption);
				Graphics.OSReleaseDC();
				Graphics.BltToBackBuffer();
				if(GameMain.Status2==7 && Menu.Open!=TRUE)
					GameMain.RenderLiquids();
				Graphics.GetDC();
				DrawIcon(Graphics.xdc,GameMain.MouseX,
						 GameMain.MouseY,GameMain.Cursor);
				Graphics.ReleaseDC();
				Graphics.Flip();
			}
			else 
			{
				Graphics.Lock();
				Graphics.DrawButton(Bx,By,Bx2,By2);
				DrawPicture(FALSE);
				Graphics.UnLock();
				Graphics.OSGetDC();
				Graphics.Text((Bx+Bx2)/2,By+3,caption);
				Graphics.OSReleaseDC();
				Graphics.BltToBackBuffer();
				if(GameMain.Status2==7 && Menu.Open!=TRUE)
					GameMain.RenderLiquids();
				Graphics.GetDC();
				DrawIcon(Graphics.xdc,GameMain.MouseX,
						 GameMain.MouseY,GameMain.Cursor);
				Graphics.ReleaseDC();
				Graphics.Flip();
			}
		}
		if(GameMain.CheckMouseRange(Bx,By,Bx2,By2,FALSE))
		{
			waspressed=TRUE;
			return(TRUE);
		}
		else return(FALSE);
	}
	else
	{
		if(waspressed)
		{
			waspressed=FALSE;
			Graphics.Lock();
			Graphics.DrawButton(Bx,By,Bx2,By2);
			DrawPicture(FALSE);
			Graphics.UnLock();
			Graphics.OSGetDC();
			Graphics.Text((Bx+Bx2)/2,By+3,caption);
			Graphics.OSReleaseDC();
		}
		return(FALSE);
	}
}

//////////////////////////////////////////////////////////////////////////////////

BOOL CButton::DrawPicture(BOOL pressed)
{
	RGBTRIPLE color;

	if(!isTextured) return(TRUE);

	int	width=Texture->width;
	int height=Texture->height;

	for(int i=0;i<width;i++)
		for(int i2=0;i2<height;i2++)
	{
		color=Texture->GetPixel(i,i2);
		if(!pressed)
		{
			if((Bx+i)>(Bx2-2)) continue;
			if((By+i2)>(By2-2)) continue;

			if(color.rgbtRed == 255
				&& color.rgbtGreen == 255
				&& color.rgbtBlue == 255)
				continue;

			Graphics.PutPixel(Bx+1+i,By+1+i2,
							  color.rgbtRed,color.rgbtGreen,color.rgbtBlue);
		}
		else
		{
			if((Bx+i)>(Bx2-2)) continue;
			if((By+i2)>(By2-3)) continue;
			
			if(color.rgbtRed == 255
				&& color.rgbtGreen == 255
				&& color.rgbtBlue == 255)
				continue;

			Graphics.PutPixel(Bx+1+i,By+2+i2,
							  color.rgbtRed,color.rgbtGreen,color.rgbtBlue);
		}
	}

	return(TRUE);
}
